// process.h : Declaration of the Cprocess

#ifndef __PROCESS_H_
#define __PROCESS_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// Cprocess
class ATL_NO_VTABLE Cprocess : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<Cprocess, &CLSID_process>,
	public ISupportErrorInfo,
	public IDispatchImpl<Iprocess, &IID_Iprocess, &LIBID_SYSLEVELLib>
{
public:
	Cprocess()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_PROCESS)
DECLARE_NOT_AGGREGATABLE(Cprocess)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(Cprocess)
	COM_INTERFACE_ENTRY(Iprocess)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// Iprocess
public:
	STDMETHOD(getCurrentProcessId)(/*[out, retval]*/ LONG *pPID);
	STDMETHOD(kill)(/*[in]*/ LONG dwProcessId, /*[out, retval]*/ LONG *result);
	STDMETHOD(get)(/*[in]*/ BSTR name, /*[out, retval]*/ LONG *dwProcessId);
};

#endif //__PROCESS_H_
